"use strict";

var utils = require('./utils');

var constants = require('./constants');

var request = utils.request;
var proceedExtraParams = utils.proceedExtraParams;

module.exports = function search(keyword, options, type) {
  var searchParams = {};

  if (type && ~['imdb', 'tvdb', 'themoviedb', 'tvrage'].indexOf(type)) {
    searchParams["search_".concat(type)] = keyword;
  } else {
    searchParams.search_string = keyword;
  }

  var extraParams = proceedExtraParams(options);
  return request(constants.BASE_URL, Object.assign({}, {
    mode: 'search'
  }, searchParams, extraParams)).then(function (res) {
    if (res.body.error) {
      return Promise.reject(res.body);
    } else {
      return res.body.torrent_results;
    }
  });
};